#include "ClassPad.h"
#include <math.h>
#include <stdio.h>
#include "cphard.h"
#include "Maze3D.h"


LINT px=96<<2;
LINT py=96<<2;



LINT angle=0;

class TT:public PegWindow
{
public:
    TT(PegRect rect):PegWindow(rect,FF_THIN)
     {
     }
     void Draw();
   	
   	void Go();
} ;   


void TT::Draw()
{

    BeginDraw();
    BITMAP *screen = CP_Bdisp_GetAddress_VRAM();


    memset(screen,0,(20*240));

              int larg=0;
             for(LINT ap=(30<<1);ap>-(30<<1);ap--)
             {

                LINT a = (angle<<1) + ap;
                LINT aa = Circular(a,360<<1);
                 
                unsigned char wh,wv;
                LINT texh,texv;
                LINT dh = GetDistH(px>>2,py>>2,aa,&wh,&texh);
                LINT dv = GetDistV(px>>2,py>>2,aa,&wv,&texv);
                
                LINT aaa = Circular(a-(angle<<1),360<<1);
                
               if (dh<dv){
                           
                    //LINT dm = (640*4)/((dh*cost[aaa])>>7);
                    LINT dm = (64*16)/((dh*cost[aaa])>>7);
                    if (dm>128)
                    continue;
                    
                    for(LINT b=-dm;b<dm;b++)
                    {
                        LINT texy = ((b+dm)<<5)/(2*dm);
                        LINT texx = (texh<<5)>>6;
                        //if ((Texs[wh%4])[(texy<<4)+texx])                    
                        if (GetPixelTex(texx,texy,(wh-1)%10))
                           SetPixel(larg,b+120,screen);
                    }
                }else{
                    //LINT dm = (640*4)/((dv*cost[aaa])>>7);
                    LINT dm = (64*16)/((dv*cost[aaa])>>7);
                    if (dm>128)
                    continue;
                    
                    for(LINT b=-dm;b<dm;b++)
                    {
                        LINT texy = ((b+dm)<<5)/(2*dm);
                        LINT texx = (texv<<5)>>6;
                        //if ((Texs[wv%4])[(texy<<4)+texx])
                         if (GetPixelTex(texx,texy,(wv-1)%10))
                           SetPixel(larg,b+120,screen);
                      
                    }
                    
                }        
                larg++;
             }    






    EndDraw();
    
}



void PegAppInitialize(PegPresentationManager *pPresentation)
{
    
	// create some simple Windows: 
	PegRect Rect;
	//Rect.Set(MAINFRAME_LEFT, MAINFRAME_TOP, MAINFRAME_RIGHT, MAINFRAME_BOTTOM-STATUS_HEIGHT);
    Rect.Set(0,0,159,239);
    TT *mw=new TT(Rect);

    Init();
	pPresentation->Add(mw);
	mw->Go();
};


void TT::Go()
{
       while(1) { 

  Invalidate();     
  Draw();
  
  
  
        if((GetKey(0x63))||(GetKey(0x45)))
        {
        angle+=4;
        angle=angle%360;
        }
        
        if((GetKey(0x73))||(GetKey(0x42)))
        {
        angle-=4;
        angle=angle%360;
        while(angle<0)
           angle+=360;

        }
        

        if((GetKey(0x74))||(GetKey(0x54)))
        {
        int cx = (4*cost[angle<<1])/(128/4);
        int cy = -(4*sint[angle<<1])/(128/4);
        
        
        if ((Map[(((py>>2)-16)>>6)*MAPSX +((((px+cx)>>2)-16)>>6)]==0)&&(Map[(((py>>2)-16)>>6)*MAPSX + ((((px+cx)>>2)+16)>>6)]==0)&&(Map[(((py>>2)+16)>>6)*MAPSX+((((px+cx)>>2)-16)>>6)]==0)&&(Map[(((py>>2)+16)>>6)*MAPSX + ((((px+cx)>>2)+16)>>6)]==0))
        px+= cx;
        
        if ((Map[((((py+cy)>>2)-16)>>6)*MAPSX +(((px>>2)-16)>>6)]==0)&&(Map[((((py+cy)>>2)+16)>>6)*MAPSX + (((px>>2)-16)>>6)]==0)&&(Map[((((py+cy)>>2)-16)>>6)*MAPSX +(((px>>2)+16)>>6)]==0)&&(Map[((((py+cy)>>2)+16)>>6)*MAPSX +(((px>>2)+16)>>6)]==0))
        py+= cy;
        }

        if((GetKey(0x64))||(GetKey(0x34)))
        {
        int cx = -(4*cost[angle<<1])/(128/4);
        int cy = (4*sint[angle<<1])/(128/4);
        
        
        if ((Map[(((py>>2)-16)>>6)*MAPSX +((((px+cx)>>2)-16)>>6)]==0)&&(Map[(((py>>2)-16)>>6)*MAPSX + ((((px+cx)>>2)+16)>>6)]==0)&&(Map[(((py>>2)+16)>>6)*MAPSX+((((px+cx)>>2)-16)>>6)]==0)&&(Map[(((py>>2)+16)>>6)*MAPSX + ((((px+cx)>>2)+16)>>6)]==0))
        px+= cx;
        
        if ((Map[((((py+cy)>>2)-16)>>6)*MAPSX +(((px>>2)-16)>>6)]==0)&&(Map[((((py+cy)>>2)+16)>>6)*MAPSX + (((px>>2)-16)>>6)]==0)&&(Map[((((py+cy)>>2)-16)>>6)*MAPSX +(((px>>2)+16)>>6)]==0)&&(Map[((((py+cy)>>2)+16)>>6)*MAPSX +(((px>>2)+16)>>6)]==0))
        py+= cy;
       }

  
  
      
  if (GetKey(0x75))
     break;
   }        

}    







//////////////////////////////////////////////////////////////////

extern "C" char *ExtensionGetLang(ID_MESSAGE MessageNo)
{
	return "";
}


