
//////////////////////////////////////////////////////////////////////
// THIS IS NOT SUPPORTED, AND IT ONLY WORKS UNDER SH
//
// NOTE: You could easily emulate these functions under Windows using the
// GetKeyState or GetKeyboardState functions.

#ifndef WIN32

#include <machine.h>
#include "bcommon.h"
#include "cphard.h"

#define	IO_PFCBASE		0xA4000100
#define	IO_PBCR			(0xA4000102 - IO_PFCBASE)
#define	IO_PORTBASE		0xA4000120
#define	IO_PADR			(0xA4000120 - IO_PORTBASE)
#define	IO_PBDR			(0xA4000122 - IO_PORTBASE)

//////////////////////////////////////////////////////////////////////
// Check the status of a single key
//
// NOTE: code is a HEX encoded byte where the upper nibble is a
// row-scan and the lower nibble is a col-scan.
int GetKey(KEY_CODE code)
{
	int i;
	int flag = 0;
	int ret = 1;
	unsigned char bRegester , bKi , bKo , bKiMask , bKoMask;
	const unsigned short usKoState[] = {0xAAA9u , 0xAAA6u , 0xAA9Au , 0xAA6Au , 
				0xA9AAu , 0xA6AAu , 0x9AAAu , 0x6AAAu};

    bKi = (code) >> 4;
    bKo = (code) & 0x0f;
	if (bKi > 7 || bKo >> 7) {
        return 0;
    }    
    bKiMask = 0x01;
	bKiMask <<= bKi;
	bKoMask = 0x01;
	bKoMask <<= bKo;
	set_gbr((VP)IO_PFCBASE);
	gbr_write_word(IO_PBCR , usKoState[bKo]);
	set_gbr((VP)IO_PORTBASE);
	gbr_write_byte(IO_PBDR , ~bKoMask);
	for(i = 0 ; i < 5 ; i++){
		bRegester = ~gbr_read_byte(IO_PADR);
		if(!(bRegester & bKiMask))
			flag++;
	}
	if(flag)
		ret = 0;
	set_gbr((VP)IO_PFCBASE);
	gbr_write_word(IO_PBCR , 0xAAAAu);
	gbr_write_word(IO_PBCR , 0x5555u);
	set_gbr((VP)IO_PORTBASE);
	gbr_write_byte(IO_PBDR , 0x00);
	return ret;
}

//////////////////////////////////////////////////////////////////////
// Check the status of the keyboard using a 8*8 (64) byte array
//
int GetKeyboard(char* keybuffer)
{
	int i , j;
	KEY_CODE code;
	int ret = 0;
	for(i = 0 ; i < 8 ; i++)
    {
        code = i << 4;
    	for(j = 0 ; j < 8 ; j++)
        {
            if (*keybuffer = GetKey(code)) ret = 1;
			code++;
			keybuffer++;
		}
	}	
	return ret;
}





void SetPixel(int x,int y,unsigned char *screen)
{
 int n = x>>3;
 unsigned char mask = (0x80)>>( x - (n<<3));

 if ((y>239)||(y<0)||(x>159)||(x<0))
    return;
 
 
 screen[ (y<<4) + (y<<2) + n ] |= mask;   
}    

void SetPixelH(int x,int y,unsigned char *screen)
{
    SetPixel(y,239-x,screen);
}   

#endif
