#include <math.h>
#include <stdio.h>
#include "peg.hpp"
#define PI 3.1415926535898
#define MAPSX 16
#define MAPSY 16
#define MAXDIST ((MAPSX+MAPSY)*64)


typedef long int LINT;

extern LINT cost[360<<1];
extern LINT sint[360<<1];
extern LINT tant[360<<1];
extern unsigned char Map[MAPSX*MAPSY];
extern unsigned char *Texs[];
extern PegBitmap gbTexturesBitmap;


inline LINT Circular(LINT v,LINT c){
    LINT r = v%c;
    while(r<0)
      r+=c;
    return r;
};

void Init();
LINT GetDistH(LINT x,LINT y,LINT angle,unsigned char *Wall,LINT *tex);
LINT GetDistV(LINT x,LINT y,LINT angle,unsigned char *Wall,LINT *tex);
int GetPixelTex(LINT x,LINT y,unsigned char texnum);
